library(stockassessment)
load("run/model.RData")
FC<-list()
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,1,1,1), label="SQ all years")
#set.seed(12345)
#FC[[length(FC)+1]] <- forecast(fit, fscale=c(1,NA,NA,NA), fval=c(NA,0.000001,0.000001, 0.000001), label="SQ then zero")
#save(FC, file="run/forecast.RData")

#Fmsy=0.28
#Fmsylower=0.21
#Fmsyupper=0.33
#Fpa=0.35
#Flim=0.49
#Btrigger=Bpa=72907
#Blim=52076

set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,NA,0.28,.28), fscale=c(1,NA,NA,NA), catchval=c(NA,43226,NA,NA), label="Fmsy", ave.years=max(fit$data$years) + ((-2):(0)), 
									rec.years=1989:2021, savesim=TRUE)
set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,NA,NA,0.28,.28), fscale=c(1, 1,NA,NA,NA), catchval=c(NA,NA,43226,NA,NA), ave.years=max(fit$data$years) + ((-2):(0)),
                                    label="Fmsy base 2021", rec.years=1989:2021, savesim=TRUE, year.base=2021)

set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,NA,NA,0.21,.21), fscale=c(1,1,NA,NA,NA), catchval=c(NA,NA,43226,NA,NA), ave.years=max(fit$data$years) + ((-2):(0)),
									label="MSY approach, Fmsy lower", rec.years=1989:2021, savesim=TRUE, year.base=2021)

set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,NA,NA,0.33,.33), fscale=c(1,1,NA,NA,NA), catchval=c(NA,NA,43226,NA,NA), ave.years=max(fit$data$years) + ((-2):(0)),
									label="MSY approach, Fmsy upper", rec.years=1989:2021, savesim=TRUE, year.base=2021)

set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,NA,NA,NA,NA), fscale=c(1,1,NA,NA,NA), catchval=c(NA,NA,43226,0,0), ave.years=max(fit$data$years) + ((-2):(0)),
									label="zero catch", rec.years=1989:2021, savesim=TRUE,year.base=2021)

set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,NA,NA,.49,.49), fscale=c(1,1,NA,NA,NA), catchval=c(NA,NA,43226,NA,NA), ave.years=max(fit$data$years) + ((-2):(0)),
									label="Other options, Flim", rec.years=1989:2021, savesim=TRUE, year.base=2021)

### 'manual' calculations 

blim=52076
obj<-function(FF){
  set.seed(123456)
  fc<-forecast(fit, fval=c(NA,NA,NA,FF,FF), fscale=c(1,1,NA,NA,NA), catchval=c(NA,NA,43226,NA,NA), ave.years=max(fit$data$years) + ((-2):(0)), label="SSB(2025)=Blim", rec.years=1989:2021,
             savesim=TRUE, year.base=2021)
  attributes(fc)$shorttab[3,"2025"]
}
FFblim<-uniroot(function(FF)obj(FF)-blim, interval=c(0.001, 2))$root
Bpa=72907

FFbpa<-uniroot(function(FF)obj(FF)-Bpa, interval=c(0.001, 2))$root

obj<-function(FF){
  set.seed(123456)
  fc<-forecast(fit, fval=c(NA,NA,NA,FF,FF), fscale=c(1,1,NA,NA,NA), catchval=c(NA,NA,43226,NA,NA), ave.years=max(fit$data$years) + ((-2):(0)), label="SSB(2025)=Blim", rec.years=1989:2021,
             savesim=TRUE, year.base=2021)
  attributes(fc)$shorttab[3,"2025"]-attributes(fc)$shorttab[3,"2024"]
}
FF24<-uniroot(obj, interval=c(0.001, 2))$root
                                  
set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,NA,NA,FFblim,FFblim), fscale=c(1,1,NA,NA,NA), catchval=c(NA,NA,43226,NA,NA), 
									ave.years=max(fit$data$years) + ((-2):(0)),
									label="SSB(2025)=Blim", rec.years=1989:2021, savesim=TRUE, year.base=2021)

set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,NA,NA,FFbpa,FFbpa), fscale=c(1,1,NA,NA,NA), catchval=c(NA,NA,43226,NA,NA), 
									ave.years=max(fit$data$years) + ((-2):(0)),
									label="SSB(2025)=Bpa", rec.years=1989:2021, savesim=TRUE, year.base=2021)

set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,NA,NA,FF24,FF24), fscale=c(1,1,NA,NA,NA), catchval=c(NA,NA,43226,NA,NA), 
									ave.years=max(fit$data$years) + ((-2):(0)),
									label="SSB(2024)=SSB(2025)", rec.years=1989:2021, savesim=TRUE, year.base=2021)


#set.seed(123456)
#FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,NA,NA,NA,.28), fscale=c(1,1,NA,NA,NA), catchval=c(NA,NA,43226,NA,NA), nextssb=c(NA,NA,NA,72907,NA), 
#									ave.years=max(fit$data$years) + ((-2):(0)),
#									label="SSB(2025)=Btrigger,Bpa", rec.years=1989:2021, savesim=TRUE, year.base=2021)

set.seed(123456)
FC[[length(FC)+1]] <- forecast(fit, fval=c(NA,NA,NA,.28,NA), fscale=c(1,1,NA,NA,1), catchval=c(NA,NA,43226,NA,NA), ave.years=max(fit$data$years) + ((-2):(0)),
									label="Other options, F=F(2023)", rec.years=1989:2021, savesim=TRUE,year.base=2021)







Blim=52076
above<-function(x){xx<-mean(x[[4]]$ssb>Blim);yr<-x[[4]]$year; round(xx*100,1)}
Pabove<-lapply(FC, above)
names(Pabove)<-lapply(FC, function(x){attr(x,"label")})
Pabove<-as.matrix(unlist(Pabove))
colnames(Pabove)<-paste0("P(SSB",FC[[1]][[4]]$year, " > ",Blim,") in %")


save(FC, Pabove, file="run/forecast.RData")